Make --nobuild_runfiles_links work in combination with --run_under

When both of these flags are provided, we must make sure that a "bazel
run" forcefully instantiates the runfiles directories both for the
target to run, and the --run_under target. Right now it only ensures
this for the former, which causes execution errors along the lines of:

Cannot find .runfiles directory for /some/path

This code alters the existing code block that ensures that runfiles
exist to loop over the entire set of targets. We do need to capture the
path of the runfiles directory of the target to run, as it may need be
used as the working directory later on.

Closes #14471.

PiperOrigin-RevId: 419734836
diff --git a/src/main/java/com/google/devtools/build/lib/runtime/commands/RunCommand.java b/src/main/java/com/google/devtools/build/lib/runtime/commands/RunCommand.java
index a4df080..1e2d6cf 100644
--- a/src/main/java/com/google/devtools/build/lib/runtime/commands/RunCommand.java
+++ b/src/main/java/com/google/devtools/build/lib/runtime/commands/RunCommand.java
@@ -370,26 +370,37 @@
           Code.RUN_PREREQ_UNMET);
     }
 
-    Path runfilesDir;
-    FilesToRunProvider provider = targetToRun.getProvider(FilesToRunProvider.class);
-    RunfilesSupport runfilesSupport = provider == null ? null : provider.getRunfilesSupport();
+    // Ensure runfiles directories are constructed, both for the target to run
+    // and the --run_under target. The path of the runfiles directory of the
+    // target to run needs to be preserved, as it acts as the working directory.
+    Path targetToRunRunfilesDir = null;
+    RunfilesSupport targetToRunRunfilesSupport = null;
+    for (ConfiguredTarget target : targetsBuilt) {
+      FilesToRunProvider provider = target.getProvider(FilesToRunProvider.class);
+      RunfilesSupport runfilesSupport = provider == null ? null : provider.getRunfilesSupport();
 
-    if (runfilesSupport == null) {
-      runfilesDir = env.getWorkingDirectory();
-    } else {
-      try {
-        runfilesDir = ensureRunfilesBuilt(env, runfilesSupport,
-            env.getSkyframeExecutor().getConfiguration(env.getReporter(),
-                targetToRun.getConfigurationKey()));
-      } catch (RunfilesException e) {
-        env.getReporter().handle(Event.error(e.getMessage()));
-        return BlazeCommandResult.failureDetail(e.createFailureDetail());
-      } catch (InterruptedException e) {
-        env.getReporter().handle(Event.error("Interrupted"));
-        return BlazeCommandResult.failureDetail(
-            FailureDetail.newBuilder()
-                .setInterrupted(Interrupted.newBuilder().setCode(Interrupted.Code.INTERRUPTED))
-                .build());
+      if (runfilesSupport != null) {
+        try {
+          Path runfilesDir =
+              ensureRunfilesBuilt(
+                  env,
+                  runfilesSupport,
+                  env.getSkyframeExecutor()
+                      .getConfiguration(env.getReporter(), target.getConfigurationKey()));
+          if (target == targetToRun) {
+            targetToRunRunfilesDir = runfilesDir;
+            targetToRunRunfilesSupport = runfilesSupport;
+          }
+        } catch (RunfilesException e) {
+          env.getReporter().handle(Event.error(e.getMessage()));
+          return BlazeCommandResult.failureDetail(e.createFailureDetail());
+        } catch (InterruptedException e) {
+          env.getReporter().handle(Event.error("Interrupted"));
+          return BlazeCommandResult.failureDetail(
+              FailureDetail.newBuilder()
+                  .setInterrupted(Interrupted.newBuilder().setCode(Interrupted.Code.INTERRUPTED))
+                  .build());
+        }
       }
     }
 
@@ -472,9 +483,12 @@
             InterruptedFailureDetails.detailedExitCode(message));
       }
     } else {
-      workingDir = runfilesDir;
-      if (runfilesSupport != null) {
-        runfilesSupport.getActionEnvironment().resolve(runEnvironment, env.getClientEnv());
+      workingDir =
+          targetToRunRunfilesDir != null ? targetToRunRunfilesDir : env.getWorkingDirectory();
+      if (targetToRunRunfilesSupport != null) {
+        targetToRunRunfilesSupport
+            .getActionEnvironment()
+            .resolve(runEnvironment, env.getClientEnv());
       }
       try {
         List<String> args = computeArgs(targetToRun, commandLineArgs);
diff --git a/src/test/shell/bazel/runfiles_test.sh b/src/test/shell/bazel/runfiles_test.sh
index 306f18b..99918ce 100755
--- a/src/test/shell/bazel/runfiles_test.sh
+++ b/src/test/shell/bazel/runfiles_test.sh
@@ -129,4 +129,55 @@
   [[ -f bazel-bin/test.runfiles/MANIFEST ]] || fail "expected output manifest to exist"
 }
 
+# When --nobuild_runfile_links is used, "bazel run --run_under" should still
+# attempt to create the runfiles directory both for the target to run and the
+# --run_under target.
+function test_nobuild_runfile_links_with_run_under() {
+  mkdir data && echo "hello" > data/hello && echo "world" > data/world
+  create_workspace_with_default_repos WORKSPACE foo
+
+cat > hello.sh <<'EOF'
+#!/bin/bash
+set -ex
+[[ -f $0.runfiles/foo/data/hello ]]
+exec "$@"
+EOF
+cat > world.sh <<'EOF'
+#!/bin/bash
+set -ex
+[[ -f $0.runfiles/foo/data/world ]]
+exit 0
+EOF
+  chmod 755 hello.sh world.sh
+  cat > BUILD <<'EOF'
+sh_binary(
+  name = "hello",
+  srcs = ["hello.sh"],
+  data = ["data/hello"],
+)
+
+sh_binary(
+  name = "world",
+  srcs = ["world.sh"],
+  data = ["data/world"],
+)
+EOF
+
+  bazel build --spawn_strategy=local --nobuild_runfile_links //:hello //:world \
+    || fail "Building //:hello and //:world failed"
+
+  [[ ! -f bazel-bin/hello.runfiles/foo/data/hello ]] || fail "expected no runfile data/hello"
+  [[ ! -f bazel-bin/hello.runfiles/MANIFEST ]] || fail "expected output manifest hello to not exist"
+  [[ ! -f bazel-bin/world.runfiles/foo/data/world ]] || fail "expected no runfile data/world"
+  [[ ! -f bazel-bin/world.runfiles/MANIFEST ]] || fail "expected output manifest world to not exist"
+
+  bazel run --spawn_strategy=local --nobuild_runfile_links --run_under //:hello //:world \
+    || fail "Testing //:foo failed"
+
+  [[ -f bazel-bin/hello.runfiles/foo/data/hello ]] || fail "expected runfile data/hello to exist"
+  [[ -f bazel-bin/hello.runfiles/MANIFEST ]] || fail "expected output manifest hello to exist"
+  [[ -f bazel-bin/world.runfiles/foo/data/world ]] || fail "expected runfile data/world to exist"
+  [[ -f bazel-bin/world.runfiles/MANIFEST ]] || fail "expected output manifest world to exist"
+}
+
 run_suite "runfiles tests"